local LBF = LibStub("LibButtonFacade", true)
if not LBF then return end

local addonName = "PolMonitor"
local BfModule = LibStub("AceAddon-3.0"):GetAddon("Masque"):NewModule(addonName)

local defaults	= {
	Skin = "Blizzard",
	Gloss = 0,
	Backdrop = false,
	Colors = {},
}

function BfModule:OnInitialize()
	if not Pol_Monitor:GetButtonFacadeToggle() then return end

	--share with PolMonitor
	self.db = Pol_Monitor.db
	if( self.db == nil ) then
		print( "oops!! " );
		return
	end
	if ( self.db.global.buttonfacade == nil ) then
		print( "PolMonitor - 1st time button facade init..." );
		self.db.global.buttonfacade = {}
	end
	--self.db = self:RegisterNamespace(addonName, defaults)
	Pol_Monitor:RegisterGroupObserver("ButtonFacade", function(...) self:GroupObserverCallback(...) end)
end


function BfModule:SkinCallback(skin, gloss, backdrop, group, button, colors)
	if not group then return end
	--print( "Must remember about ".. group )
	self.db.global.buttonfacade[group].Skin = skin
	self.db.global.buttonfacade[group].Gloss = gloss
	self.db.global.buttonfacade[group].Backdrop = backdrop
	self.db.global.buttonfacade[group].Colors = colors
end

function BfModule:GroupObserverCallback(action, group, monitor)
	local groupName = group.name
	
	if action == "create" then
		local lbfGroup = LBF:Group(addonName, groupName)
		for i, monitor in ipairs(group:GetMonitors()) do
			lbfGroup:AddButton(monitor:GetButton():GetFrame())
		end
		self:SkinGroup(lbfGroup, groupName)
	elseif action == "addmonitor" then
		local lbfGroup = LBF:Group(addonName, groupName)
		lbfGroup:AddButton(monitor:GetButton():GetFrame())
		self:SkinGroup(lbfGroup, groupName)
	elseif action == "delmonitor" then
		local lbfGroup = LBF:Group(addonName, groupName)
		lbfGroup:RemoveButton(monitor:GetButton():GetFrame())
	elseif action == "delete" then
		LBF:DeleteGroup(addonName, group.name)
	end
end

function BfModule:SkinGroup(lbfGroup, groupName)
	if not self.db.global.buttonfacade[groupName] then
		self.db.global.buttonfacade[groupName] = defaults
	end
	lbfGroup:Skin(
		self.db.global.buttonfacade[groupName].Skin, self.db.global.buttonfacade[groupName].Gloss,
		self.db.global.buttonfacade[groupName].Backdrop, self.db.global.buttonfacade[groupName].Colors)
end

function BfModule:Load()
	LBF:RegisterSkinCallback(addonName, self.SkinCallback, self)
end

function BfModule:OnEnable()
	self:Load()
end
